package com.ccnode.codegenerator.mybatisGenerator.plugins;

package .tmp;

import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.FormatTools;
import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.JavaElementGeneratorTools;
import com.ccnode.codegenerator.mybatisGenerator.plugins.tools.XmlElementGeneratorTools;
import java.util.List;
import org.mybatis.generator.api.IntrospectedColumn;
import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.PluginAdapter;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.Interface;
import org.mybatis.generator.api.dom.java.JavaVisibility;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.api.dom.xml.Attribute;
import org.mybatis.generator.api.dom.xml.Document;
import org.mybatis.generator.api.dom.xml.Element;
import org.mybatis.generator.api.dom.xml.TextElement;
import org.mybatis.generator.api.dom.xml.XmlElement;
import org.mybatis.generator.codegen.mybatis3.ListUtilities;

public class BatchInsertOnDuplicatePlugin extends PluginAdapter {
  public static final String a = "batchInsertOrUpdate";
  
  public boolean validate(List<String> paramList) {
    return true;
  }
  
  public boolean clientGenerated(Interface paramInterface, TopLevelClass paramTopLevelClass, IntrospectedTable paramIntrospectedTable) {
    FullyQualifiedJavaType fullyQualifiedJavaType = FullyQualifiedJavaType.getNewListInstance();
    fullyQualifiedJavaType.addTypeArgument(paramIntrospectedTable.getRules().calculateAllFieldsClass());
    paramInterface.addImportedType(fullyQualifiedJavaType);
    Method method = JavaElementGeneratorTools.a("batchInsertOrUpdate", JavaVisibility.DEFAULT, 

        
        FullyQualifiedJavaType.getIntInstance(), new Parameter[] { new Parameter(new FullyQualifiedJavaType(fullyQualifiedJavaType
              .getShortName()), "list", "@Param(\"list\")") });
    FormatTools.a(paramInterface, method);
    return true;
  }
  
  public boolean sqlMapDocumentGenerated(Document paramDocument, IntrospectedTable paramIntrospectedTable) {
    String str = paramIntrospectedTable.getContext().getProperty("dbType");
    if (!str.equals("Oracle")) {
      XmlElement xmlElement1 = new XmlElement("insert");
      xmlElement1.addAttribute(new Attribute("id", "batchInsertOrUpdate"));
      xmlElement1.addAttribute(new Attribute("parameterType", "map"));
      getContext().getCommentGenerator().addComment(xmlElement1);
      XmlElementGeneratorTools.a(xmlElement1, paramIntrospectedTable);
      xmlElement1.addElement((Element)new TextElement("insert into " + paramIntrospectedTable.getFullyQualifiedTableNameAtRuntime()));
      for (Element element : XmlElementGeneratorTools.a(ListUtilities.removeIdentityAndGeneratedAlwaysColumns(paramIntrospectedTable.getAllColumns()), true))
        xmlElement1.addElement(element); 
      XmlElement xmlElement2 = new XmlElement("foreach");
      xmlElement2.addAttribute(new Attribute("collection", "list"));
      xmlElement2.addAttribute(new Attribute("item", "item"));
      xmlElement2.addAttribute(new Attribute("separator", ","));
      for (Element element : XmlElementGeneratorTools.a(ListUtilities.removeIdentityAndGeneratedAlwaysColumns(paramIntrospectedTable.getAllColumns()), "item."))
        xmlElement2.addElement(element); 
      xmlElement1.addElement((Element)new TextElement("values"));
      xmlElement1.addElement((Element)xmlElement2);
      xmlElement1.addElement((Element)new TextElement("on duplicate key update "));
      List<IntrospectedColumn> list = ListUtilities.removeIdentityAndGeneratedAlwaysColumns(paramIntrospectedTable.getAllColumns());
      for (byte b = 0; b < list.size(); b++) {
        IntrospectedColumn introspectedColumn = list.get(b);
        if (!introspectedColumn.isIdentity() && !introspectedColumn.isSequenceColumn())
          if (b == list.size() - 1) {
            xmlElement1.addElement((Element)new TextElement(introspectedColumn.getActualColumnName() + "=values(" + introspectedColumn.getActualColumnName() + ")"));
          } else {
            xmlElement1.addElement((Element)new TextElement(introspectedColumn.getActualColumnName() + "=values(" + introspectedColumn.getActualColumnName() + "),"));
          }  
      } 
      paramDocument.getRootElement().addElement((Element)xmlElement1);
    } 
    return true;
  }
}
